/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using Battlehub.RTCommon;using SimpleJSON;using System;using System.Collections;using System.Collections.Generic;using UnityEngine;using System.Linq;using System.Text.RegularExpressions;using UnityEngine.EventSystems;namespace PluginIdea.BLO{public class ObjectScale{public string id;public Vector3 localScale;}public class DraggedObjectTransInfo{public Vector3 position;public Quaternion rotation;public Vector3 localScale;public Vector3 forward;public Vector3 up;public Vector3 right;}public class BlenderLikeOperation : MVRScript, IGL{class OperateState{public const int NONE = 0;public const int MOVE = 1;public const int SCALE = 2;public const int ROTATE = 3;public const int MOVE_X = 4;public const int MOVE_Y = 5;public const int MOVE_Z = 6;public const int SCALE_X = 7;public const int SCALE_Y = 8;public const int SCALE_Z = 9;public const int ROTATE_X = 10;public const int ROTATE_Y = 11;public const int ROTATE_Z = 12;public const int MOVE_XY = 13;public const int MOVE_XZ = 14;public const int MOVE_YZ = 15;public const int MOVE_VIEW = 17;public const int ORBIT = 18;}public class Axis{public const int AXIS_X = 0;public const int AXIS_Y = 1;public const int AXIS_Z = 2;public const int AXIS_VIEW = 3;public const int AXIS_XY = 4;public const int AXIS_XZ = 5;public const int AXIS_YZ = 6;}public class Plane{public const int AXIS_XY = 0;public const int AXIS_XZ = 1;public const int AXIS_YZ = 2;}private bool isWorldSpace;private JSONStorableBool isSnap;private JSONStorableFloat rotateSnap;private JSONStorableString targetsScalingSave;private JSONStorableBool disableColliderWhenOperation;private JSONStorableBool followMouseWhenAtomAdded;private JSONStorableFloat moveDistanceThrehold;private JSONStorableFloat moveAlignViewSpeed;private JSONStorableFloat trackBallRotateSpeed;private float basePointRadio;private FreeControllerV3 lastSelectController;private Transform controllerTransform;private Transform scaleTransform;private Rigidbody controllerRigd;private int currentState;private DraggedObjectTransInfo targetObjectBeginTransInfo;private Vector3 targetObjectBeginOffset;private Camera targetCamera;private BlenderLikeSelection blenderLikeSelection;private float lastMouseHoverOffset;private Atom lastSelectAtom;private GLDraw glDraw;private float operationBeginDistance;private float operationBeginAngle;private List<GLLine2D> lines2D;private List<GLLine3D> lines3D;private Dictionary<string, ObjectScale> dicSceneObjectsScaleChanged = new Dictionary<string, ObjectScale>();private Vector3 MousePosition{get{float hitObjectDistance = Vector3.Project(controllerTransform.position - targetCamera.transform.position, targetCamera.transform.forward).magnitude;float mouseX = Mathf.Clamp(Input.mousePosition.x, 20, Screen.currentResolution.width - 20);float mouseY = Mathf.Clamp(Input.mousePosition.y, 20, Screen.currentResolution.height - 20);return new Vector3(mouseX, mouseY, hitObjectDistance);}}private Vector3 HitObjectScreenPosition{get{return targetCamera.WorldToScreenPoint(controllerTransform.position);}}private float SignedHitObjectScreenPosDistanceToMousePosV2{get{Vector2 mouseScreenPosition = new Vector2(MousePosition.x, MousePosition.y);Vector2 hitObjectScreenPosition = new Vector2(HitObjectScreenPosition.x, HitObjectScreenPosition.y);Vector2 offset = mouseScreenPosition - hitObjectScreenPosition;float sign = offset.x >= 0 || offset.y >= 0 ? 1 : -1;return offset.magnitude * sign;}}private float HitObjectScreenPosDistanceToMousePosV2{get{Vector2 mouseScreenPosition = new Vector2(MousePosition.x, MousePosition.y);Vector2 hitObjectScreenPosition = new Vector2(HitObjectScreenPosition.x, HitObjectScreenPosition.y);return (mouseScreenPosition - hitObjectScreenPosition).magnitude;}}private bool IsHandlesEnable{get{SuperController sc = SuperController.singleton;UserPreferences up = UserPreferences.singleton;bool handlesEnabled = sc.MonitorCenterCamera != null && (!up.showTargetsMenuOnly || sc.mainHUD.gameObject.activeSelf);return handlesEnabled;}}private Vector3 ViewDirction{get{return (controllerTransform.position - targetCamera.transform.position).normalized;}}public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true){base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms, setMissingToDefault);RestoreScaleInfoFromJson();}public override void Init(){base.Init();if (SuperController.singleton.isOVR || SuperController.singleton.isOpenVR){SuperController.LogError("Not available in VR !");}blenderLikeSelection = new BlenderLikeSelection(this);UIInit();targetCamera = SuperController.singleton.MonitorCenterCamera;glDraw = new GLDraw();lines2D = new List<GLLine2D>();lines3D = new List<GLLine3D>();}private void Start(){if (GLRenderer.Instance == null){new GameObject{name = "GLRenderer"}.AddComponent<GLRenderer>();}GLRenderer.Instance.Add(this);}private void UIInit(){Utils.OnInitUI(CreateUIElement);Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.MainParameterSubtitle), 35, false);isSnap = Utils.SetupToggle(this, Location.GetStr(Location.IsSnapActive), false, false);rotateSnap = Utils.SetupSliderInt(this, Location.GetStr(Location.RotateAngleSnap), 5, 0, 90, false);moveAlignViewSpeed = Utils.SetupSliderFloat(this, Location.GetStr(Location.MoveRangeAlignViewDirction), 1f, 0f, 3f, false);moveDistanceThrehold = Utils.SetupSliderFloat(this, Location.GetStr(Location.MoveDistanceThrehold), 30, 4f, 100f, false);trackBallRotateSpeed = Utils.SetupSliderFloat(this, Location.GetStr(Location.TrackBallRotateSpeed), 1f, 0.1f, 4f, false);targetsScalingSave = Utils.SetupStorableString(this, "BlenderLikeScaleSave", "");disableColliderWhenOperation = Utils.SetupToggle(this, Location.GetStr(Location.IsDisableColliderWhenOperation), false, false);followMouseWhenAtomAdded = Utils.SetupToggle(this, Location.GetStr(Location.IsAtomFollowMouseWhenAdd), false, false);Utils.SetupInfoText(this, Location.GetStr(Location.PluginInfo), 1200, true);blenderLikeSelection.UIInit();}private void RestoreScaleInfoFromJson(){try{JSONNode jsonNode = JSONClass.Parse(targetsScalingSave.val);if (jsonNode == null) return;JSONArray scaleDatas = jsonNode.AsArray;if (scaleDatas.Count > 0){scaleDatas.Childs.ToList().ForEach(o =>{string uid = o["id"];Vector3 localScale = new Vector3(o["x"].AsFloat, o["y"].AsFloat, o["z"].AsFloat);var atom = SuperController.singleton.GetAtomByUid(uid);ObjectScale objectScale = new ObjectScale(){id = uid, localScale = localScale};if (atom != null){Utils.GetAtomRescaleObject(atom).localScale = localScale;if (!dicSceneObjectsScaleChanged.ContainsKey(uid))                                dicSceneObjectsScaleChanged.Add(uid, objectScale);}else{SuperController.LogError(string.Format("atom{0}not exist on this scene", atom.name));}});}}catch (Exception e){SuperController.LogError(e.Message);throw;}}private void AppendSelectAtomScaleInfo(Atom targetAtom){try{if (targetAtom != null){Vector3 localScale = Utils.GetAtomRescaleObject(targetAtom).localScale;if (dicSceneObjectsScaleChanged.ContainsKey(targetAtom.uid)){dicSceneObjectsScaleChanged[targetAtom.uid].localScale = localScale;}else{dicSceneObjectsScaleChanged.Add(targetAtom.uid, new ObjectScale(){id = targetAtom.uid, localScale = localScale});}ApplySceneAtomsScaleInfo();}}catch (Exception e){SuperController.LogError(e.Message);throw;}}private void ApplySceneAtomsScaleInfo(){JSONArray array = new JSONArray();dicSceneObjectsScaleChanged.Values.ToList().ForEach(data =>{JSONClass temp = new JSONClass();temp["id"] = data.id;temp["x"] = data.localScale.x.ToString();temp["y"] = data.localScale.y.ToString();temp["z"] = data.localScale.z.ToString();array.Add(temp);});targetsScalingSave.val = array.ToString();}void Update(){if (currentState == OperateState.NONE){blenderLikeSelection.Update();}lastSelectController = SuperController.singleton.GetSelectedController();if (lastSelectController == null && currentState > 0){ResetTargetObjectToBeginState();return;}RuntimeTools.PivotRotation = isWorldSpace ? RuntimePivotRotation.Global : RuntimePivotRotation.Local;if (lastSelectController == null) return;controllerTransform = lastSelectController.transform;controllerRigd = controllerTransform.parent.GetComponentInChildren<Rigidbody>();SetTransformScale setTransformScale = lastSelectController.GetComponentInParent<SetTransformScale>();if (setTransformScale == null){scaleTransform = controllerTransform.parent.Find("object/rescaleObject").transform;}else{scaleTransform = setTransformScale.transform;}if (currentState == OperateState.NONE && !EventSystem.current.IsPointerOverGameObject()){if (Input.GetKeyDown(KeyCode.G)){SwitchToMoveState();}if (Input.GetKeyDown(KeyCode.R)){SwitchToRotateState();}if (Input.GetKeyDown(KeyCode.E) && scaleTransform != null){SwitchToScaleState();}return;}if (currentState == OperateState.MOVE || currentState == OperateState.MOVE_X || currentState == OperateState.MOVE_Y || currentState == OperateState.MOVE_Z){ShowPositionHandleView();}if (currentState == OperateState.ROTATE || currentState == OperateState.ROTATE_X || currentState == OperateState.ROTATE_Y || currentState == OperateState.ROTATE_Z){ShowRotateHandleView();}if (currentState == OperateState.MOVE){Vector3 worldPosition = targetCamera.ScreenToWorldPoint(MousePosition);controllerTransform.position = worldPosition + targetObjectBeginOffset;ShowPositionHandleView();MoveStateChangeCheck();}if (currentState == OperateState.MOVE_X){MoveAlignAxis(Axis.AXIS_X);MoveStateChangeCheck();}if (currentState == OperateState.MOVE_XY){MoveAlignAxis(Axis.AXIS_XY);MoveStateChangeCheck();}if (currentState == OperateState.MOVE_YZ){MoveAlignAxis(Axis.AXIS_YZ);MoveStateChangeCheck();}if (currentState == OperateState.MOVE_XZ){MoveAlignAxis(Axis.AXIS_XZ);MoveStateChangeCheck();}if (currentState == OperateState.MOVE_Y){MoveAlignAxis(Axis.AXIS_Y);MoveStateChangeCheck();}if (currentState == OperateState.MOVE_Z){MoveAlignAxis(Axis.AXIS_Z);MoveStateChangeCheck();}if (currentState == OperateState.MOVE_VIEW){MoveAlignAxis(Axis.AXIS_VIEW);MoveStateChangeCheck();}if (currentState == OperateState.SCALE){float currentOperationDistance = HitObjectScreenPosDistanceToMousePosV2;float scaleRadio = currentOperationDistance / operationBeginDistance;basePointRadio = 1 / scaleRadio;scaleTransform.localScale = targetObjectBeginTransInfo.localScale * scaleRadio;ScaleStateChangeCheck();}if (currentState == OperateState.SCALE_X){ScaleAlignAxis(Axis.AXIS_X);ScaleStateChangeCheck();}if (currentState == OperateState.SCALE_Y){ScaleAlignAxis(Axis.AXIS_Y);ScaleStateChangeCheck();}if (currentState == OperateState.SCALE_Z){ScaleAlignAxis(Axis.AXIS_Z);ScaleStateChangeCheck();}if (currentState == OperateState.ROTATE){float currentOperationAngle = Utils.GetVectorAngleRange360((MousePosition - HitObjectScreenPosition).normalized, Vector3.right);if (isSnap.val){currentOperationAngle = currentOperationAngle - currentOperationAngle % rotateSnap.val;}Quaternion quater = Quaternion.AngleAxis(currentOperationAngle - operationBeginAngle, ViewDirction);controllerTransform.rotation = quater * targetObjectBeginTransInfo.rotation;RotateStateChangeCheck();}if (currentState == OperateState.ROTATE_X){RotateAlignAxis(Axis.AXIS_X);RotateStateChangeCheck();}if (currentState == OperateState.ROTATE_Y){RotateAlignAxis(Axis.AXIS_Y);RotateStateChangeCheck();}if (currentState == OperateState.ROTATE_Z){RotateAlignAxis(Axis.AXIS_Z);RotateStateChangeCheck();}if (currentState == OperateState.ORBIT){TrackBallRotate();RotateStateChangeCheck();}if (Input.GetKeyDown(KeyCode.Space)){if (currentState == OperateState.SCALE || currentState == OperateState.SCALE_X || currentState == OperateState.SCALE_Y || currentState == OperateState.SCALE_Z){AppendSelectAtomScaleInfo(SuperController.singleton.GetSelectedAtom());}currentState = OperateState.NONE;EnabelTargetCollider();}if (Input.GetMouseButtonDown(2) && currentState != OperateState.NONE){ResetTargetObjectToBeginState();}}private void SwitchToScaleState(){currentState = OperateState.SCALE;DisableTargetCollider();BackUpBeginTransInfo();operationBeginDistance = HitObjectScreenPosDistanceToMousePosV2;if (operationBeginDistance == 0) operationBeginDistance = 1;SetToWorldSpaceCheck();}private void SwitchToRotateState(){currentState = OperateState.ROTATE;DisableTargetCollider();BackUpBeginTransInfo();operationBeginAngle = Utils.GetVectorAngleRange360((MousePosition - HitObjectScreenPosition).normalized, Vector3.right);SetToWorldSpaceCheck();}private void SwitchToMoveState(){currentState = OperateState.MOVE;DisableTargetCollider();BackUpBeginTransInfo();operationBeginDistance = HitObjectScreenPosDistanceToMousePosV2;if (operationBeginDistance == 0) operationBeginDistance = 1;targetObjectBeginOffset = targetObjectBeginTransInfo.position - targetCamera.ScreenToWorldPoint(MousePosition);SetToWorldSpaceCheck();}private void ShowRotateHandleView(){FCRotationHandle rotationHandle = SuperController.singleton.selectedControllerRotationHandle;if (rotationHandle != null){if (rotationHandle.enabled && !IsHandlesEnable)                    rotationHandle.ForceDeselectAxis();rotationHandle.enabled = IsHandlesEnable;}}private void ShowPositionHandleView(){FCPositionHandle positionHandle = SuperController.singleton.selectedControllerPositionHandle;if (positionHandle != null){if (positionHandle.enabled && IsHandlesEnable)                    positionHandle.ForceDeselectAxis();positionHandle.enabled = IsHandlesEnable;}}private void SetToWorldSpaceCheck(){if (Input.GetKey(KeyCode.LeftShift)){isWorldSpace = true;}}private void EnabelTargetCollider(){if (disableColliderWhenOperation.val){controllerRigd.isKinematic = false;}}private void DisableTargetCollider(){if (disableColliderWhenOperation.val){controllerRigd.isKinematic = true;}}private void OnDestroy(){blenderLikeSelection = null;glDraw = null;Utils.OnDestroyUI();GLRenderer.Instance.Remove(this);}private void RotateStateChangeCheck(){if (Input.GetKeyDown(KeyCode.Alpha1)){currentState = OperateState.ROTATE_X;}else if (Input.GetKeyDown(KeyCode.Alpha2)){currentState = OperateState.ROTATE_Y;}else if (Input.GetKeyDown(KeyCode.Alpha3)){currentState = OperateState.ROTATE_Z;}else if (Input.GetKeyDown(KeyCode.R)){currentState = OperateState.ORBIT;lastMouseHoverOffset = HitObjectScreenPosDistanceToMousePosV2;}else if (Input.GetKeyDown(KeyCode.Alpha4)){currentState = OperateState.NONE;controllerTransform.localRotation = Quaternion.identity;}}private void ScaleStateChangeCheck(){if (Input.GetKeyDown(KeyCode.Alpha1)){currentState = OperateState.SCALE_X;}else if (Input.GetKeyDown(KeyCode.Alpha2)){currentState = OperateState.SCALE_Y;}else if (Input.GetKeyDown(KeyCode.Alpha3)){currentState = OperateState.SCALE_Z;}else if (Input.GetKeyDown(KeyCode.E)){currentState = OperateState.NONE;scaleTransform.localScale = Vector3.one;}}private void MoveStateChangeCheck(){if (Input.GetKeyDown(KeyCode.Alpha1)){if (Input.GetKey(KeyCode.LeftShift)){currentState = OperateState.MOVE_XY;}else{currentState = OperateState.MOVE_X;}}else if (Input.GetKeyDown(KeyCode.Alpha2)){if (Input.GetKey(KeyCode.LeftShift)){currentState = OperateState.MOVE_YZ;}else{currentState = OperateState.MOVE_Y;}}else if (Input.GetKeyDown(KeyCode.Alpha3)){if (Input.GetKey(KeyCode.LeftShift)){currentState = OperateState.MOVE_XZ;}else{currentState = OperateState.MOVE_Z;}}else if (Input.GetKeyDown(KeyCode.V)){currentState = OperateState.MOVE_VIEW;}else if (Input.GetKeyDown(KeyCode.G)){currentState = OperateState.NONE;controllerTransform.position = Vector3.zero;}}float last;private void MoveAlignAxis(int axis){Ray ray = targetCamera.ScreenPointToRay(Input.mousePosition);Vector3 intersectPoint = Vector3.zero;if (isWorldSpace){if (axis == Axis.AXIS_X){if (Mathf.Abs(Vector3.Dot(Vector3.back, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, Vector3.back, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = new Vector3(intersectPoint.x, targetObjectBeginTransInfo.position.y, targetObjectBeginTransInfo.position.z);}else if (axis == Axis.AXIS_Y){if (Mathf.Abs(Vector3.Dot(Vector3.back, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, Vector3.back, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = new Vector3(targetObjectBeginTransInfo.position.x, intersectPoint.y, targetObjectBeginTransInfo.position.z);}else if (axis == Axis.AXIS_Z){if (Mathf.Abs(Vector3.Dot(Vector3.up, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, Vector3.up, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = new Vector3(targetObjectBeginTransInfo.position.x, targetObjectBeginTransInfo.position.y, intersectPoint.z);}else if (axis == Axis.AXIS_XY){if (Mathf.Abs(Vector3.Dot(Vector3.back, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, Vector3.back, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = intersectPoint;}else if (axis == Axis.AXIS_YZ){if (Mathf.Abs(Vector3.Dot(Vector3.left, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, Vector3.left, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = intersectPoint;}else if (axis == Axis.AXIS_XZ){if (Mathf.Abs(Vector3.Dot(Vector3.up, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, Vector3.up, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = intersectPoint;}}else{if (axis == Axis.AXIS_VIEW){float currentOperationDistance = HitObjectScreenPosDistanceToMousePosV2;float moveRadio = (currentOperationDistance - operationBeginDistance) / operationBeginDistance;Vector3 controllerTargetPosition = targetObjectBeginTransInfo.position - ViewDirction * moveRadio * moveAlignViewSpeed.val;if ((controllerTargetPosition - targetCamera.transform.position).magnitude < 1f ||                        Vector3.Dot(targetCamera.transform.forward, (controllerTargetPosition - targetCamera.transform.position).normalized) < 0){moveRadio = last;}last = moveRadio;basePointRadio = 1 / (moveRadio + 1);controllerTransform.position = targetObjectBeginTransInfo.position - ViewDirction * moveRadio * moveAlignViewSpeed.val;}else{Vector3 offsetVec = Vector3.zero;if (axis == Axis.AXIS_X){if (Mathf.Abs(Vector3.Dot(targetObjectBeginTransInfo.forward, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, targetObjectBeginTransInfo.forward, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;Vector3 intersectPointVec = intersectPoint - targetObjectBeginTransInfo.position;offsetVec = Utils.VecProject(intersectPointVec, targetObjectBeginTransInfo.right);controllerTransform.position = targetObjectBeginTransInfo.position + offsetVec;}else if (axis == Axis.AXIS_Y){if (Mathf.Abs(Vector3.Dot(targetObjectBeginTransInfo.forward, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, targetObjectBeginTransInfo.forward, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;Vector3 intersectPointVec = intersectPoint - targetObjectBeginTransInfo.position;offsetVec = Utils.VecProject(intersectPointVec, targetObjectBeginTransInfo.up);controllerTransform.position = targetObjectBeginTransInfo.position + offsetVec;}else if (axis == Axis.AXIS_Z){if (Mathf.Abs(Vector3.Dot(targetObjectBeginTransInfo.up, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, targetObjectBeginTransInfo.up, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;Vector3 intersectPointVec = intersectPoint - targetObjectBeginTransInfo.position;offsetVec = Utils.VecProject(intersectPointVec, targetObjectBeginTransInfo.forward);controllerTransform.position = targetObjectBeginTransInfo.position + offsetVec;}else if (axis == Axis.AXIS_XY){if (Mathf.Abs(Vector3.Dot(targetObjectBeginTransInfo.forward, -ray.direction)) < 0.001f ) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, targetObjectBeginTransInfo.forward, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = intersectPoint;}else if (axis == Axis.AXIS_YZ){if (Mathf.Abs(Vector3.Dot(-targetObjectBeginTransInfo.right, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, targetObjectBeginTransInfo.right, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = intersectPoint;}else if (axis == Axis.AXIS_XZ){if (Mathf.Abs(Vector3.Dot(targetObjectBeginTransInfo.up, -ray.direction)) < 0.001f) return;intersectPoint = Utils.GetIntersectPointWithRay(targetObjectBeginTransInfo.position, targetObjectBeginTransInfo.up, ray);if (Vector3.Distance(targetObjectBeginTransInfo.position, intersectPoint) > moveDistanceThrehold.val) return;controllerTransform.position = intersectPoint;}}}}private void ScaleAlignAxis(int axis){float currentOperationDistance = HitObjectScreenPosDistanceToMousePosV2;float scaleRadio = currentOperationDistance / operationBeginDistance;basePointRadio = 1 / scaleRadio;if (axis == Axis.AXIS_X){scaleTransform.localScale = new Vector3(targetObjectBeginTransInfo.localScale.x * scaleRadio, targetObjectBeginTransInfo.localScale.y, targetObjectBeginTransInfo.localScale.z);}else if (axis == Axis.AXIS_Y){scaleTransform.localScale = new Vector3(targetObjectBeginTransInfo.localScale.x, targetObjectBeginTransInfo.localScale.y * scaleRadio, targetObjectBeginTransInfo.localScale.z);}else if (axis == Axis.AXIS_Z){scaleTransform.localScale = new Vector3(targetObjectBeginTransInfo.localScale.x, targetObjectBeginTransInfo.localScale.y, targetObjectBeginTransInfo.localScale.z * scaleRadio);}}private void TrackBallRotate(){Vector2 mouseScreenPosition = new Vector2(MousePosition.x, MousePosition.y);Vector2 hitObjectScreenPosition = new Vector2(HitObjectScreenPosition.x, HitObjectScreenPosition.y);Vector2 offset = mouseScreenPosition - hitObjectScreenPosition;Vector3 hitObjectPositionInCameraSpace = targetCamera.transform.InverseTransformPoint(targetObjectBeginTransInfo.position);Vector3 rotateAxis = (targetCamera.transform.TransformDirection(new Vector3(-offset.y, offset.x, hitObjectPositionInCameraSpace.z)).normalized);float deltaMove = offset.magnitude - lastMouseHoverOffset;this.lastMouseHoverOffset = offset.magnitude;float rotateAmount = deltaMove * trackBallRotateSpeed.val * 0.2f;controllerTransform.RotateAround(targetObjectBeginTransInfo.position, rotateAxis, rotateAmount);}private void RotateAlignAxis(int axis){float currentOperationAngle = Utils.GetVectorAngleRange360((MousePosition - HitObjectScreenPosition).normalized, Vector3.right);if (isSnap.val){currentOperationAngle = currentOperationAngle - currentOperationAngle % rotateSnap.val;}Quaternion quater = Quaternion.identity;if (isWorldSpace){if (axis == Axis.AXIS_X){quater = Quaternion.AngleAxis(currentOperationAngle - operationBeginAngle, Vector3.right);}else if (axis == Axis.AXIS_Y){quater = Quaternion.AngleAxis(currentOperationAngle - operationBeginAngle, Vector3.up);}else if (axis == Axis.AXIS_Z){quater = Quaternion.AngleAxis(currentOperationAngle - operationBeginAngle, Vector3.forward);}}else{if (axis == Axis.AXIS_X){quater = Quaternion.AngleAxis(currentOperationAngle - operationBeginAngle, targetObjectBeginTransInfo.right);}else if (axis == Axis.AXIS_Y){quater = Quaternion.AngleAxis(currentOperationAngle - operationBeginAngle, targetObjectBeginTransInfo.up);}else if (axis == Axis.AXIS_Z){quater = Quaternion.AngleAxis(currentOperationAngle - operationBeginAngle, targetObjectBeginTransInfo.forward);}}controllerTransform.rotation = quater * targetObjectBeginTransInfo.rotation;}private void BackUpBeginTransInfo(){targetObjectBeginTransInfo = new DraggedObjectTransInfo(){position = controllerTransform.position,                localScale = scaleTransform != null ? scaleTransform.localScale : Vector3.one,                rotation = controllerTransform.rotation,                forward = controllerTransform.forward,                up = controllerTransform.up,                right = controllerTransform.right,};}private void ResetTargetObjectToBeginState(){if (controllerTransform != null && targetObjectBeginTransInfo != null){controllerTransform.position = targetObjectBeginTransInfo.position;controllerTransform.rotation = targetObjectBeginTransInfo.rotation;if (scaleTransform != null){scaleTransform.localScale = targetObjectBeginTransInfo.localScale;}}currentState = OperateState.NONE;isWorldSpace = false;EnabelTargetCollider();}void OnPostRender(){if (currentState > 0){if (Camera.current.name == "ScreenUICamera") return;if (lines2D.Count > 0){lines2D.Clear();}if (lines3D.Count > 0){lines3D.Clear();}Vector2 beginPosition = targetCamera.WorldToScreenPoint(targetObjectBeginTransInfo.position);if (currentState == OperateState.MOVE || currentState == OperateState.MOVE_X || currentState == OperateState.MOVE_Y || currentState == OperateState.MOVE_Z){Vector2 currentPosition = HitObjectScreenPosition;lines2D.Add(new GLLine2D(){from = Utils.MapScreenPosTo01(beginPosition), to = Utils.MapScreenPosTo01(currentPosition)});glDraw.DrawLine2D(lines2D, Color.white);}else if (currentState == OperateState.MOVE_VIEW){Vector2 currentPosition = MousePosition;Vector2 v1 = Utils.MapScreenPosTo01(beginPosition);Vector2 v2 = Utils.MapScreenPosTo01(currentPosition);Vector2 direction = (v2 - v1).normalized;float length = (v2 - v1).magnitude;Vector2 leftPoint = v2 + 0.1f * length * (direction + Utils.GetVerticalVectorFrom(direction));Vector2 rightPoint = v2 + 0.1f * length * (direction - Utils.GetVerticalVectorFrom(direction));Vector2 basePointEnd = v1 + direction * length * basePointRadio;Vector2 leftBasePoint = v1 + length * basePointRadio * direction + Utils.GetVerticalVectorFrom(direction) * 0.1f * length;Vector2 rightBasePoint = v1 + length * basePointRadio * direction - Utils.GetVerticalVectorFrom(direction) * 0.1f * length;lines2D.Add(new GLLine2D(){from = v1, to = v2});lines2D.Add(new GLLine2D(){from = v2, to = leftPoint});lines2D.Add(new GLLine2D(){from = v2, to = rightPoint});lines2D.Add(new GLLine2D(){from = v1, to = basePointEnd});lines2D.Add(new GLLine2D(){from = leftBasePoint, to = rightBasePoint});glDraw.DrawLine2D(lines2D, Color.white);}else if (currentState == OperateState.SCALE || currentState == OperateState.SCALE_X || currentState == OperateState.SCALE_Y || currentState == OperateState.SCALE_Z){Vector2 currentPosition = MousePosition;Vector2 v1 = Utils.MapScreenPosTo01(beginPosition);Vector2 v2 = Utils.MapScreenPosTo01(currentPosition);Vector2 direction = (v2 - v1).normalized;float length = (v2 - v1).magnitude;Vector2 leftPoint = v2 - 0.1f * length * (direction + Utils.GetVerticalVectorFrom(direction));Vector2 rightPoint = v2 - 0.1f * length * (direction - Utils.GetVerticalVectorFrom(direction));Vector2 basePointEnd = v1 + direction * length * basePointRadio;Vector2 leftBasePoint = v1 + length * basePointRadio * direction + Utils.GetVerticalVectorFrom(direction) * 0.1f * length;Vector2 rightBasePoint = v1 + length * basePointRadio * direction - Utils.GetVerticalVectorFrom(direction) * 0.1f * length;lines2D.Add(new GLLine2D(){from = v1, to = v2});lines2D.Add(new GLLine2D(){from = v2, to = leftPoint});lines2D.Add(new GLLine2D(){from = v2, to = rightPoint});lines2D.Add(new GLLine2D(){from = v1, to = basePointEnd});lines2D.Add(new GLLine2D(){from = leftBasePoint, to = rightBasePoint});glDraw.DrawLine2D(lines2D, Color.white);}else if (currentState == OperateState.ROTATE || currentState == OperateState.ROTATE_X || currentState == OperateState.ROTATE_Y || currentState == OperateState.ROTATE_Z){Vector2 currentPosition = MousePosition;Vector2 v1 = Utils.MapScreenPosTo01(beginPosition);Vector2 v2 = Utils.MapScreenPosTo01(currentPosition);Vector2 direction = (v2 - v1).normalized;float length = (v2 - v1).magnitude;Vector2 leftPoint = v2 + 0.1f * length * Utils.GetVerticalVectorFrom(direction);Vector2 rightPoint = v2 - 0.1f * length * Utils.GetVerticalVectorFrom(direction);lines2D.Add(new GLLine2D(){from = v1, to = v2});lines2D.Add(new GLLine2D(){from = v2, to = leftPoint});lines2D.Add(new GLLine2D(){from = v2, to = rightPoint});glDraw.DrawLine2D(lines2D, Color.white);}if (isWorldSpace){lines3D.Add(new GLLine3D(){from = targetObjectBeginTransInfo.position - Vector3.right * 100, to = targetObjectBeginTransInfo.position + Vector3.right * 100, color = Color.red});lines3D.Add(new GLLine3D(){from = targetObjectBeginTransInfo.position - Vector3.forward * 100, to = targetObjectBeginTransInfo.position + Vector3.forward * 100, color = Color.blue});lines3D.Add(new GLLine3D(){from = targetObjectBeginTransInfo.position - Vector3.up * 100, to = targetObjectBeginTransInfo.position + Vector3.up * 100, color = Color.green});}else{lines3D.Add(new GLLine3D(){from = targetObjectBeginTransInfo.position - targetObjectBeginTransInfo.right * 100, to = targetObjectBeginTransInfo.position + targetObjectBeginTransInfo.right * 100, color = Color.red});lines3D.Add(new GLLine3D(){from = targetObjectBeginTransInfo.position - targetObjectBeginTransInfo.forward * 100, to = targetObjectBeginTransInfo.position + targetObjectBeginTransInfo.forward * 100, color = Color.blue});lines3D.Add(new GLLine3D(){from = targetObjectBeginTransInfo.position - targetObjectBeginTransInfo.up * 100, to = targetObjectBeginTransInfo.position + targetObjectBeginTransInfo.up * 100, color = Color.green});}glDraw.DrawLine3D(lines3D, null, Color.white);}else{blenderLikeSelection.OnPostRender();}}public void Draw(int cullingMask){OnPostRender();}}}